org.apache.hc.core5.http.io.entity

## Class NullEntity

- java.lang.Object
- - org.apache.hc.core5.http.io.entity.NullEntity

- All Implemented Interfaces:
    Closeable, AutoCloseable, EntityDetails, HttpEntity

      @Contract(threading=IMMUTABLE)
      public final class NullEntity
      extends Object
      implements HttpEntity

  An empty entity with no content-type. This type may be used for convenience in place of an empty `ByteArrayEntity`.
  Since:
    5.1

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static NullEntity` | `INSTANCE`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()`
    `InputStream` | `getContent()` Returns a content stream of the entity.
    `String` | `getContentEncoding()` Returns content encoding of the entity, if known.
    `long` | `getContentLength()` Returns length of the entity, if known.
    `String` | `getContentType()` Returns content type of the entity, if known.
    `Set<String>` | `getTrailerNames()` Preliminary declaration of trailing headers.
    `Supplier<List<? extends Header>>` | `getTrailers()` Returns supplier of message trailers - headers sent after message body.
    `boolean` | `isChunked()` Returns chunked transfer hint for this entity.
    `boolean` | `isRepeatable()` Tells if the entity is capable of producing its data more than once.
    `boolean` | `isStreaming()` Tells whether this entity depends on an underlying stream.
    `void` | `writeTo(OutputStream outStream)` Writes the entity content out to the output stream.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### INSTANCE

          public static final NullEntity INSTANCE

  - ### Method Detail

    - #### isRepeatable

          public boolean isRepeatable()

      Description copied from interface: `HttpEntity`
      Tells if the entity is capable of producing its data more than once. A repeatable entity's getContent() and writeTo(OutputStream) methods can be called more than once whereas a non-repeatable entity's can not.
      Specified by:
        `isRepeatable` in interface `HttpEntity`
      Returns:
        true if the entity is repeatable, false otherwise.

    - #### getContent

          public InputStream getContent()
                                 throws IOException,
                                        UnsupportedOperationException

      Description copied from interface: `HttpEntity`
      Returns a content stream of the entity. `Repeatable` entities are expected to create a new instance of `InputStream` for each invocation of this method and therefore can be consumed multiple times. Entities that are not `repeatable` are expected to return the same `InputStream` instance and therefore may not be consumed more than once.

      If this entity belongs to an incoming HTTP message, calling `InputStream.close()` on the returned `InputStream` will try to consume the complete entity content to keep the connection alive. In cases where this is undesired, e.g. when only a small part of the content is relevant and consuming the complete entity content would be too inefficient, only the HTTP message from which this entity was obtained should be closed (if supported).

      IMPORTANT: Please note all entity implementations must ensure that all allocated resources are properly deallocated after the `InputStream.close()` method is invoked.

      Specified by:
        `getContent` in interface `HttpEntity`
      Returns:
        content stream of the entity.
      Throws:
        `IOException` - if the stream could not be created
        `UnsupportedOperationException` - if entity content cannot be represented as `InputStream`.
      See Also:
        `HttpEntity.isRepeatable()`

    - #### writeTo

          public void writeTo(OutputStream outStream)
                       throws IOException

      Description copied from interface: `HttpEntity`
      Writes the entity content out to the output stream.

      IMPORTANT: Please note all entity implementations must ensure that all allocated resources are properly deallocated when this method returns.

      Specified by:
        `writeTo` in interface `HttpEntity`
      Parameters:
        `outStream` - the output stream to write entity content to
      Throws:
        `IOException` - if an I/O error occurs

    - #### isStreaming

          public boolean isStreaming()

      Description copied from interface: `HttpEntity`
      Tells whether this entity depends on an underlying stream. Streamed entities that read data directly from the socket should return `true`. Self-contained entities should return `false`. Wrapping entities should delegate this call to the wrapped entity.
      Specified by:
        `isStreaming` in interface `HttpEntity`
      Returns:
        `true` if the entity content is streamed, `false` otherwise

    - #### getTrailers

          public Supplier<List<? extends Header>> getTrailers()

      Description copied from interface: `HttpEntity`
      Returns supplier of message trailers - headers sent after message body. May return `null` if trailers are not available.
      Specified by:
        `getTrailers` in interface `HttpEntity`

    - #### close

          public void close()
                     throws IOException

      Specified by:
        `close` in interface `Closeable`
      Specified by:
        `close` in interface `AutoCloseable`
      Throws:
        `IOException`

    - #### getContentLength

          public long getContentLength()

      Description copied from interface: `EntityDetails`
      Returns length of the entity, if known.
      Specified by:
        `getContentLength` in interface `EntityDetails`

    - #### getContentType

          public String getContentType()

      Description copied from interface: `EntityDetails`
      Returns content type of the entity, if known.
      Specified by:
        `getContentType` in interface `EntityDetails`

    - #### getContentEncoding

          public String getContentEncoding()

      Description copied from interface: `EntityDetails`
      Returns content encoding of the entity, if known.
      Specified by:
        `getContentEncoding` in interface `EntityDetails`

    - #### isChunked

          public boolean isChunked()

      Description copied from interface: `EntityDetails`
      Returns chunked transfer hint for this entity.

      The behavior of wrapping entities is implementation dependent, but should respect the primary purpose.

      Specified by:
        `isChunked` in interface `EntityDetails`

    - #### getTrailerNames

          public Set<String> getTrailerNames()

      Description copied from interface: `EntityDetails`
      Preliminary declaration of trailing headers.
      Specified by:
        `getTrailerNames` in interface `EntityDetails`

Copyright © 2005–2022 The Apache Software Foundation. All rights reserved.